"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Connection = void 0;
const querystring_1 = __importDefault(require("querystring"));
const axios_1 = __importDefault(require("axios"));
const authUrl = 'https://fcis.ice.ibmcloud.com/';
class Connection {
    constructor(config, log) {
        this.config = config;
        this.log = log;
    }
    auth() {
        return __awaiter(this, void 0, void 0, function* () {
            const url = authUrl + 'v1.0/endpoint/default/token';
            const options = {
                method: 'POST',
                url: url,
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                    'User-Agent': 'fordpass-na/353 CFNetwork/1121.2.2 Darwin/19.3.0',
                },
                data: querystring_1.default.stringify({
                    client_id: '9fb503e0-715b-47e8-adfd-ad4b7770f73b',
                    grant_type: 'password',
                    username: this.config.username,
                    password: this.config.password,
                }),
            };
            try {
                const result = yield (0, axios_1.default)(options);
                if (result.status === 200) {
                    this.config.access_token = result.data.access_token;
                    return true;
                }
                else {
                    this.log.error(`Auth failed with status: ${result.status}`);
                }
                return false;
            }
            catch (error) {
                this.log.error(`Auth failed with error: ${error.code || error.response.status}`);
                return false;
            }
        });
    }
}
exports.Connection = Connection;
//# sourceMappingURL=fordpass-connection.js.map